package com.prolog.eis.service.out;


import com.prolog.eis.model.container.ContainerInfoDetail;
import com.prolog.eis.model.container.ContainerStoreChange;
import com.prolog.eis.vo.GoodsInfoVO;
import com.prolog.framework.core.restriction.Criteria;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * @author zmr
 * @description: 容器库存变动表-服务接口类
 * @date 2023-08-30 12:24
 */
public interface ContainerStoreChangeService {

    /**
     * 新增数据
     *
     * @param containerStoreChange 容器库存变动表
     */
    long save(ContainerStoreChange containerStoreChange);

    /**
     * 新增批量数据
     *
     * @param containerStoreChangeList 容器库存变动表
     */
    long saveBatch(List<ContainerStoreChange> containerStoreChangeList);

    /**
     * 查询多条数据
     *
     * @param paramMap 查询起始位置
     * @return 对象列表
     */
    List<ContainerStoreChange> findByMap(Map<String, Object> paramMap);

    /**
     * 查询单条数据
     *
     * @param paramMap 查询起始位置
     * @return 对象
     */
    ContainerStoreChange findOneByMap(Map<String, Object> paramMap);

    /**
     * 查询多条数据
     *
     * @param criteria 查询起始位置
     * @return 对象列表
     */
    List<ContainerStoreChange> findByCriteria(Criteria criteria);

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    ContainerStoreChange findById(int id);

    /**
     * 修改数据
     *
     * @param containerStoreChange 实例对象
     */
    long update(ContainerStoreChange containerStoreChange);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     */
    long deleteById(int id);

    /**
     * 通过参数删除数据
     *
     * @param paramMap 参数
     */
    long deleteByMap(Map<String, Object> paramMap);

    /**
     * 通过参数查询总条数
     *
     * @param paramMap 参数
     */
    long findCountByMap(Map<String, Object> paramMap);

    void saveContainerStoreChange(String containerNo, String containerSubNo, GoodsInfoVO vo, int taskType,
                                  BigDecimal soureQty, BigDecimal changeQty, String msg, String upperSystemId);

    public void saveStoreChange(ContainerInfoDetail containerInfoDetail, BigDecimal change, BigDecimal target, Integer workType, String remark);
}
